B - 小学生 POJ - 3126 Prime Path

B - 小学生

 POJ - 3126 

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 

1033 
1733 
3733 
3739 
3779 
8779 
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

 题意:给你两个四位素数,每次改变其中一位,使得改后依旧是素数,求多少步第一个素数可以变成第二个

爆搜,每次改变一个数字(4*10),搜索是否可行

#include <iostream>
#include <cstring>
#include <cstdio>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <algorithm>
#include <math.h>

typedef long long LL;
typedef long double LD;
using namespace std;
const int  maxn=10;
int vis[maxn][maxn][maxn][maxn];
int f[8][2]={{-1,-1},{-1,0},{-1,1},{0,-1},{0,1},{1,-1},{1,0},{1,1}};
int n,m;
struct node
{
    int a[5];
    int step;
};
queue<node>q;
bool OK(node t,node en)
{
    for(int i=1;i<=4;i++)
    {
        if(t.a[i]!=en.a[i])
        {
            return false;
        }
    }
    return true;
}
bool ss(node x)
{
    int xx=0;
    for(int i=1;i<=4;i++)
    {
        xx=xx*10+x.a[i];
    }
    for(int i=2;i<=sqrt(xx);i++)
    {
        if(xx%i==0)return false;
    }
    return true;
}
void bfs(node st,node en)
{
    q.push(st);
    while(!q.empty())
    {
        node t=q.front();
       // printf("t:%d%d%d%d  %d\n",t.a[1],t.a[2],t.a[3],t.a[4],t.step);
        q.pop();
        if(OK(t,en))
        {
            printf("%d\n",t.step);
            return;
        }
        for(int i=1;i<=4;i++)
        {
            for(int j=1;j<=9;j++)
            {
                node tem;
                tem.a[1]=t.a[1];
                tem.a[2]=t.a[2];
                tem.a[3]=t.a[3];
                tem.a[4]=t.a[4];
                tem.step=t.step+1;
                tem.a[i]+=j;
                tem.a[i]%=10;
                if(tem.a[1]==0)continue;

                if(!ss(tem)||vis[tem.a[1]][tem.a[2]][tem.a[3]][tem.a[4]]!=0)continue;
                q.push(tem);
                vis[tem.a[1]][tem.a[2]][tem.a[3]][tem.a[4]]=1;
                //printf("tem:%d%d%d%d\n",tem.a[1],tem.a[2],tem.a[3],tem.a[4]);
            }
        }
    }
    printf("Impossible\n");
}
int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        int x,y;
        scanf("%d%d",&x,&y);
        memset(vis,0,sizeof(vis));
        while(!q.empty())q.pop();
        node st,en;
        st.step=0;
        int i=4;
        while(x){st.a[i]=x%10;x/=10;i--;}
        vis[st.a[1]][st.a[2]][st.a[3]][st.a[4]]=1;
        i=4;
        while(y){en.a[i]=y%10;y/=10;i--;}
        bfs(st,en);

    }
    return 0;
}

 

posted on 2018-08-01 12:34  一零七  阅读(125)  评论(0编辑  收藏  举报

导航